#include <check.h>
#include <errno.h>
#include <stdio.h>
#include <unistd.h>

#include "ttail_check.h"
#include "ttail.h"
#include "ttail_init.h"

START_TEST (test_init_check_bad1)
{
	ck_assert_int_eq(ttail_init_check(ttail), -1);
}
END_TEST

START_TEST (test_init_check_bad2)
{
	ttail->flag |= TTAIL_FLAG_DATE_MAX;
	ck_assert_int_eq(ttail_init_check(ttail), -1);
}
END_TEST

START_TEST (test_init_check1)
{
	char *arg[] = {"88/10/22", NULL};
	struct tm zero;
	char *arg0;

	arg0 = malloc(sizeof(char)*(strlen(arg[0])+1));
	if(!arg0)
	{
		perror("Malloc failed for argument");
		ck_abort_msg("Unable to allocate memory");
	}
	strcpy(arg0, arg[0]);
	arg[0]=arg0;

	memset(&zero, 0, sizeof(struct tm));

	ttail_set_dates(ttail, arg);
	ck_assert_int_eq(ttail_init_check(ttail), 0);
}
END_TEST

Suite * ttail_init_suite(void)
{
	Suite *s;
	TCase	*tc_init_check;

	s = suite_create("ttail init checks");

	tc_init_check = tcase_create("ttail_init_check() checks");
	tcase_add_checked_fixture(tc_init_check,
		setup_ttail_empty, teardown_ttail);
	tcase_add_test(tc_init_check, test_init_check_bad1);
	tcase_add_test(tc_init_check, test_init_check_bad2);
	tcase_add_test(tc_init_check, test_init_check1);

	suite_add_tcase(s, tc_init_check);
	return s;
}

TTAIL_CHECK_MAIN(ttail_init_suite)
