#include <check.h>
#include <errno.h>
#include <stdio.h>
#include <unistd.h>

#include "ttail_check.h"
#include "ttail.h"
#include "ttail_init.h"

/*
 * ttail_set_fmt() checks
 */
START_TEST (test_init_fmt)
{
	int ret;
	ret = ttail_set_fmt(ttail, "%B");
	ck_assert_int_eq(ret, 0);
	ck_assert_int_eq(ttail->flag & TTAIL_FLAG_FORMAT, TTAIL_FLAG_FORMAT);
	ck_assert_str_eq(ttail->fmt, "%B");
}
END_TEST

START_TEST (test_init_fmt_again)
{
	int ret;
	ttail_set_fmt(ttail, "%B");
	ret = ttail_set_fmt(ttail, "%b");
	ck_assert_int_eq(ret, -1);
	ck_assert_int_eq(ttail->flag & TTAIL_FLAG_FORMAT, TTAIL_FLAG_FORMAT);
	ck_assert_str_eq(ttail->fmt, "%B");
}
END_TEST

Suite * ttail_init_suite(void)
{
	Suite *s;
	TCase	*tc_init_fmt;

	s = suite_create("ttail init checks");

	tc_init_fmt = tcase_create("date format init checks");
	tcase_add_checked_fixture(tc_init_fmt,
		setup_ttail_empty, teardown_ttail);
	tcase_add_test(tc_init_fmt, test_init_fmt);
	tcase_add_test(tc_init_fmt, test_init_fmt_again);

	suite_add_tcase(s, tc_init_fmt);
	return s;
}

TTAIL_CHECK_MAIN(ttail_init_suite)
