#include <check.h>
#include <stdio.h>
#include <libgen.h>

#include "ttail_check.h"
#include "ttail.h"
#include "ttail_init.h"
#include "ttail_search.h"

START_TEST (test_search_closest_init)
{
	int ret;

	ret = ttail_search_files_init(ttail);
	ck_assert_int_eq(ret,0);
	ck_assert(ttail->session->file.vpos == 0);
	#ifdef HUGEFILE
	ck_assert_int_eq(ttail->session->file.sz_div,0);
	#endif
}
END_TEST

START_TEST (test_search_closest_init_filesz)
{
	size_t i;
	ttail_search_files_init(ttail);
	for(i=0;i<6;i++)
	{
		ck_assert(samples_sz[i] == ttail->session->file.file_sz[i]);
	}

}
END_TEST

START_TEST (test_search_closest_init_vfile)
{
	size_t i;
	off_t full_sz;

	ttail_search_files_init(ttail);

	full_sz = 0;
	for(i=0;i<6;i++)
	{
		ck_assert(full_sz == ttail->session->file.vfile[i]);
		full_sz += samples_sz[i];
	}
	ck_assert(full_sz == ttail->session->file.vsz);
}
END_TEST

Suite * ttail_search_files_suite(void)
{
	Suite *s;
	TCase *tc_search_closest_fileinit;

	s = suite_create("ttail search_files checks");

	tc_search_closest_fileinit = tcase_create("\
ttail_logline_closest_files_init() checks");
	tcase_add_checked_fixture(tc_search_closest_fileinit,
		setup_closest_fileinit, teardown_closest_fileinit);
	tcase_add_test(tc_search_closest_fileinit, test_search_closest_init);
	tcase_add_test(tc_search_closest_fileinit,
		test_search_closest_init_filesz);
	tcase_add_test(tc_search_closest_fileinit,
		test_search_closest_init_vfile);

	suite_add_tcase(s, tc_search_closest_fileinit);
	return s;
}

TTAIL_CHECK_MAIN(ttail_search_files_suite)
